%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%                                                         %
% Fichier principal qui charge les blocs dans un fichier  %
% M-files et appelle successivement les irrations du     %
% filtre de Kalman ou du filtre de Kalman  temps continu %
%                                                         %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% paramtres

taille        = 10 ;
nbredonnee    = 1000000 ;
nbrebloc=100 ;

% paramtre du filtre de Kalman  temps continu  faire varier entre 0 et 1
% Si lambda=1, on a le filtre de Kalman
lambda = 1;


% INITIALISATION
testFailed = 0; %variable test vrifiant si le filtre de Kalman filter 
                % termine correctement...
x = zeros(taille,1);
H = 0;

A = [];
b = [];


% Itre sur tous les blocs...
for i=1:nbrebloc
    
    %---------------------------------------------------------------------%
    % CHARGEZ LES BLOCS ICI                                               %
    % functions utiles: 
    %            strcat(string, string) : merges two strings...           %
    %            int2str(nbr): converts a number to a string              %
    %            load(string): loads input in  file string.mat (cf enonce)%
    %                                                                     %
    %---------------------------------------------------------------------%
    
    j = i; % run over blocs in normal order....
    
    % Load of the data blocks
    Cj = strcat('C',int2str(j));
    zj = strcat('z',int2str(j));   
    load(zj) 
    load(Cj)
   
    % Aprs appel, le block est la variable C et le block du membre de  
    % droite est la variables z.
    % Reconstruisez A et b pour rsoudre x = A\b avec la fonction matlab....
    
    A = [A;C];
    b = [b;z];
    
    
    
    % appel au filtre de Kalman avec paramtre lambda
    [H,x,testFailed] = kalman(C,z,H,x,lambda,taille, testFailed);
    if testFailed == 1
        return
    end
    
    % solution actuelle
    %x
    %stock(i,1)=norm(x);
end

% Si on a reconstruit la matrice entire A, rsoudre x = A\b...
disp('Solution using matlab MSE function:')
    %TODO: xGauss = .....

%Solution optimale aprs avoir valu tous les blocs
xKalm = x;


disp('Valeur de l''optimum avec Kalman:');
xKalm

